<?php

/**
 * @file
 * Theme for gliderjs views.
 */

use Drupal\gliderjs\Plugin\views\style\Gliderjs;

/**
 * Prepares variables for template.
 *
 * @param array $variables
 *   An associative array.
 */
function template_preprocess_gliderjs(array &$variables) {
  if (isset($variables['view']) && $variables['view']->style_plugin instanceof Gliderjs) {
    $options = $variables['view']->style_plugin->options;

    $image_field_name = $options['image_field_name'];
    $view = $variables['view'];
    $rows = $variables['rows'];

    if (!$image_field_name || !isset($view->field[$image_field_name])) {
      return;
    }

    $images = [];
    foreach ($rows as $row) {
      foreach ($row['#row']->_entity->{$image_field_name} as $image) {
        $images[] = $image;
      }
    }
    $variables['images'] = $images;
    $variables['#attached']['library'][] = 'gliderjs/gliderjs';
    $variables['#attached']['drupalSettings']['gliderjs'] = [
      'slides_to_show' => $options['slides_to_show'],
      'slides_to_scroll' => $options['slides_to_scroll'],
      'show_arrows' => $options['show_arrows'],
      'show_dots' => $options['show_dots'],
      'item_width' => $options['item_width'],
      'exact_width' => $options['exact_width'],
      'scroll_lock' => $options['scroll_lock'],
      'scroll_lock_delay' => $options['scroll_lock_delay'],
      'resize_lock' => $options['resize_lock'],
      'rewind' => $options['rewind'],
      'draggable' => $options['draggable'],
      'drag_velocity' => $options['drag_velocity'],
      'duration' => $options['duration'],
      'breakpoint_settings' => $options['breakpoint_settings'],
    ];
  }
}
